//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.cm"
//////////4 times frames RSI 2 levels Modified by Sohocool
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Green
#property indicator_color6  Red
#property indicator_color7  Green
#property indicator_color8  Red
#property indicator_minimum 0
#property indicator_maximum 5

//
//
//
//
//

extern string TimeFrame1            = "next3";
extern string TimeFrame2            = "next2";
extern string TimeFrame3            = "next1";
extern string TimeFrame4            = "Current time frame";


extern int    FastPeriod                =  5;//8
extern int    SlowPeriod                = 15;//15
extern int    SignalPeriod              = 1;//10
extern int    Price                     = PRICE_CLOSE;
extern int    Method                    = MODE_EMA;
extern string UniqueID              = "MACD DEMA";
extern int    LinesWidth            = 0;
extern color  LabelsColor           = DarkGray;
extern int    LabelsHorizontalShift = 5;
extern double LabelsVerticalShift   = 1.5;
extern bool   alertsOn              = false;
extern int    alertsLevel           = 4;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = true;
extern bool   alertsEmail           = false;

//
//
//
//
//

double adx1u[];
double adx1d[];
double adx2u[];
double adx2d[];
double adx3u[];
double adx3d[];
double adx4u[];
double adx4d[];

int    timeFrames[4];
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,adx1u);
   SetIndexBuffer(1,adx1d);
   SetIndexBuffer(2,adx2u);
   SetIndexBuffer(3,adx2d);
   SetIndexBuffer(4,adx3u);
   SetIndexBuffer(5,adx3d);
   SetIndexBuffer(6,adx4u);
   SetIndexBuffer(7,adx4d);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars");     if (returnBars)     return(0);
      
      //
      //
      //
      //
      //
      
      for (int i=0; i<8; i++) 
      {
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth); SetIndexArrow(i,110); 
      }
      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      timeFrames[2] = stringToTimeFrame(TimeFrame3);
      timeFrames[3] = stringToTimeFrame(TimeFrame4);
      alertsLevel = MathMin(MathMax(alertsLevel,3),4);
     // IndicatorShortName((UniqueID)+"("+Rsiperiod+"," + Levelup + ","+Leveldown+")");
      IndicatorShortName(UniqueID);
   return(0);
}
int deinit()
{
   for (int t=0; t<4; t++) ObjectDelete(UniqueID+t);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _up 0
#define _dn 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { adx1u[0] = limit+1; return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         if (timeFrames[1] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,"returnBars",0,0)*timeFrames[1]/Period()));
         if (timeFrames[2] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[2],indicatorFileName,"returnBars",0,0)*timeFrames[2]/Period()));
         if (timeFrames[3] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[3],indicatorFileName,"returnBars",0,0)*timeFrames[3]/Period()));
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

         //
         //
         //
         //
         //
         
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<4; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+t,label,8,"Arial");
            }               
         }
         for (t=0; t<4; t++) ObjectSet(UniqueID+t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   //
   //
   //
   //
    
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,y);
         double buffer5 = iCustomMa(Method,price,FastPeriod,i,0)-iCustomMa(Method,price,SlowPeriod,y,1);
         double buffer6 = iCustomMa(Method,buffer5,SignalPeriod,y,2);
         double b4price = iMA(NULL,0,1,0,MODE_SMA,Price,y+1);
         double b4buffer5 = iCustomMa(Method,b4price,FastPeriod,y+1,0)-iCustomMa(Method,b4price,SlowPeriod,y+1,1);
         double b4buffer6 = iCustomMa(Method,b4buffer5,SignalPeriod,y+1,2);
                        
            switch (k)
            {
               case 0 : adx1d[i] = EMPTY_VALUE; adx1u[i] = EMPTY_VALUE; if (buffer6>b4buffer6) {adx1u[i] = k+1; trend[r][_up] += 1;} if (buffer6<b4buffer6) {adx1d[i] = k+1;trend[r][_dn] += 1;}  break;
               case 1 : adx2d[i] = EMPTY_VALUE; adx2u[i] = EMPTY_VALUE; if (buffer6>b4buffer6) {adx2u[i] = k+1; trend[r][_up] += 1;} if (buffer6<b4buffer6) {adx2d[i] = k+1;trend[r][_dn] += 1;}  break;
               case 2 : adx3d[i] = EMPTY_VALUE; adx3u[i] = EMPTY_VALUE; if (buffer6>b4buffer6) {adx3u[i] = k+1; trend[r][_up] += 1;} if (buffer6<b4buffer6) {adx3d[i] = k+1;trend[r][_dn] += 1;}  break;
               case 3 : adx4d[i] = EMPTY_VALUE; adx4u[i] = EMPTY_VALUE; if (buffer6>b4buffer6) {adx4u[i] = k+1; trend[r][_up] += 1;} if (buffer6<b4buffer6) {adx4d[i] = k+1;trend[r][_dn] += 1;}  break;
            }
            
      }
   }
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1;
      if (trend[whichBar][_up] >= alertsLevel || trend[whichBar][_dn] >= alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel) doAlert("UP"  ,trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel) doAlert("DOWN",trend[whichBar][_dn]);
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat, int howMany)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" MACD DEMA ==>> "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" 4 time frame RSI",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
/*string methodNames[] = {"Double EMA"};
string getAverageName(int& method)
{
   int max = ArraySize(methodNames)-1;
      method=MathMax(MathMin(method,max),0); return(methodNames[method]);
}*/

#define _maWorkBufferx1 3
#define _maWorkBufferx2 6
#define _maWorkBufferx3 9

double iCustomMa(int mode, double price, double length, int i, int instanceNo=0)
{
   int r = Bars-i-1;
   switch (mode)
   {
      
      case 0  : return(iDema(price,length,r,instanceNo));
     
      default : return(0);
   }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------


double workDema[][_maWorkBufferx2];
#define _ema1 0
#define _ema2 1

double iDema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workDema,0)!= Bars) ArrayResize(workDema,Bars); instanceNo*=2;

   double alpha = 2.0 / (1.0+period);
          workDema[r][_ema1+instanceNo] = workDema[r-1][_ema1+instanceNo]+alpha*(price                        -workDema[r-1][_ema1+instanceNo]);
          workDema[r][_ema2+instanceNo] = workDema[r-1][_ema2+instanceNo]+alpha*(workDema[r][_ema1+instanceNo]-workDema[r-1][_ema2+instanceNo]);
   return(workDema[r][_ema1+instanceNo]*2.0-workDema[r][_ema2+instanceNo]);
}
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}